## ros-noetic-spinnaker-camera-driver 0.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

set_directory_properties(PROPERTIES COMPILE_OPTIONS "-std=c++11;-Wall;-Wextra")


project(spinnaker_camera_driver)

find_package(catkin REQUIRED COMPONENTS
  camera_info_manager diagnostic_updater dynamic_reconfigure
  image_exposure_msgs image_transport nodelet roscpp sensor_msgs
  wfov_camera_msgs
)

generate_dynamic_reconfigure_options(
  cfg/Spinnaker.cfg
)

catkin_package(CATKIN_DEPENDS
  image_exposure_msgs nodelet roscpp sensor_msgs wfov_camera_msgs
)


# If Spinnacker is already present, use the found version. If not, download it.
# We can't resolve this dependency using the usual rosdep means because
# the Point Grey EULA prohibits redistributing the headers or the packages which
# contains them. We work around this by downloading the archive directly from
# their website during this step in the build process.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
find_package(Spinnaker QUIET)
if(NOT Spinnaker_FOUND)
  message(STATUS "libSpinnaker not found in system library path")
  include(cmake/DownloadSpinnaker.cmake)
  download_spinnaker(Spinnaker_LIBRARIES Spinnaker_INCLUDE_DIRS)
endif()

message(STATUS "libSpinnaker library: ${Spinnaker_LIBRARIES}")
message(STATUS "libSpinnaker include: ${Spinnaker_INCLUDE_DIRS}")


include_directories(SYSTEM
                    ${Spinnaker_INCLUDE_DIRS}
                    ${catkin_INCLUDE_DIRS})
include_directories(include)

add_library(SpinnakerCameraLib src/SpinnakerCamera.cpp)

# Include the Spinnaker Libs
target_link_libraries(SpinnakerCameraLib
                      Camera
                      ${Spinnaker_LIBRARIES}
                      ${catkin_LIBRARIES})


# Test Executable for Spinnaker
add_executable(spinnaker_test_node
              src/spinnaker_test_node.cpp
)

target_link_libraries(spinnaker_test_node
  SpinnakerCameraLib
  ${catkin_LIBRARIES}
)


add_dependencies(SpinnakerCameraLib ${PROJECT_NAME}_gencfg)


add_library(Camera src/camera.cpp)
target_link_libraries(Camera ${catkin_LIBRARIES})
add_dependencies(Camera ${PROJECT_NAME}_gencfg)

add_library(Cm3 src/cm3.cpp)
target_link_libraries(Cm3 Camera ${catkin_LIBRARIES})
add_dependencies(Cm3 ${PROJECT_NAME}_gencfg)

add_library(Gh3 src/gh3.cpp)
target_link_libraries(Gh3 Camera ${catkin_LIBRARIES})
add_dependencies(Gh3 ${PROJECT_NAME}_gencfg)

add_library(Diagnostics src/diagnostics.cpp)
target_link_libraries(Diagnostics Camera SpinnakerCameraLib ${catkin_LIBRARIES})
add_dependencies(Diagnostics ${PROJECT_NAME}_gencfg)

add_library(SpinnakerCameraNodelet src/nodelet.cpp)
target_link_libraries(SpinnakerCameraNodelet Diagnostics SpinnakerCameraLib Camera Gh3 Cm3 ${catkin_LIBRARIES})

add_executable(spinnaker_camera_node src/node.cpp)
target_link_libraries(spinnaker_camera_node SpinnakerCameraLib ${catkin_LIBRARIES})
set_target_properties(spinnaker_camera_node PROPERTIES OUTPUT_NAME camera_node PREFIX "")

install(TARGETS
  SpinnakerCameraLib
  SpinnakerCameraNodelet
  Camera
  Cm3
  Gh3
  Diagnostics
  spinnaker_camera_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Redistributing the flycapture .so file is permitted by the SDK EULA:
# http://www.ptgrey.com/support/kb/data/PGR-FlyCap-SDK-LA.pdf
if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/usr/lib)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/usr/lib/ DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
           PATTERN libQt* EXCLUDE)
else()
  get_filename_component(Spinnaker_LIB_DIR ${Spinnaker_LIBRARIES} DIRECTORY)
  file(READ ${PROJECT_SOURCE_DIR}/cmake/install_files filenames)
  foreach(filename ${filenames})
    install(FILES ${Spinnaker_LIB_DIR}/${filename} DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
  endforeach()
endif()

install(FILES nodelet_plugins.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} )

install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(roslaunch REQUIRED)
  roslaunch_add_file_check(launch/camera.launch)

  find_package(roslint REQUIRED)
  set(ROSLINT_CPP_OPTS "--filter=-build/c++11")
  roslint_cpp()
  roslint_add_test()
endif()

=== debian/changelog ===
ros-noetic-spinnaker-camera-driver (0.2.5-1buster) buster; urgency=high

  * Fixed arm64 folder name.
  * Contributors: Tony Baltovski

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Fri, 06 Jan 2023 05:00:00 -0000

ros-noetic-spinnaker-camera-driver (0.2.4-1buster) buster; urgency=high

  * Fixed typo in arm64 arch.
  * Contributors: Tony Baltovski

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Fri, 06 Jan 2023 05:00:00 -0000

ros-noetic-spinnaker-camera-driver (0.2.3-1buster) buster; urgency=high

  * Only install necessary libraries
  * 0.2.2
  * Changes.
  * Added new-line at EOF
  * Spinnaker libraries are now all copied to usr/lib
  * Reordered definitions to prevent compiler warnings
  * 0.2.1
  * Changes.
  * Removed check for build/usr/lib which would cause build to skip Spinnaker SDK install
  * 0.2.0
  * Changes.
  * Changes.
  * Fixed all issues reported by roslint
  * Updated file paths to /opt/spinnaker instead of /usr/spinnaker
  * Updated download_spinnaker look-up table
  * Add readable check to SDK parameters
  * URDF Description, Diagnostics, ISP Enable, and Launch Files (#81 <https://github.com/ros-drivers/flir_camera_driver/issues/81>)
    * Changes required to use GigE Blackfly S version
    * Added blackfly mesh
    * Added URDF of blackflys and CHANGELOG
    * Added new_line at end of flir_blackflys.urdf.xacro
    * Added DiagnosticAnalyzers and more detailed diagnostic messages
    * Added ISP enable and disable config and updated camera launch file to be more descriptive
    * Switched order of configuration to put ISP enable next to color encoding
    * Updated config to include enumeration for Off, Once, Continuous parameters, and udpated diagnostics.launch
    * Handled issue where no namespace prevents diagnostics_agg from loading from analyzer paramaters
  * Branch to Support GigE Cameras (#79 <https://github.com/ros-drivers/flir_camera_driver/issues/79>)
    * Changes required to use GigE Blackfly S version
    * Update SpinnakerCamera.cpp
  * Add new parameter to apply an offset to image time stamps (#56 <https://github.com/ros-drivers/flir_camera_driver/issues/56>)
  * Fixes SpinnakerCamera teardown (#16 <https://github.com/ros-drivers/flir_camera_driver/issues/16>)
    * fixes error on destroying SpinnakerCamera with multiple cameras
    * adds clarifying comment
  * Add /opt/spinnaker to spinnaker discovery options (#63 <https://github.com/ros-drivers/flir_camera_driver/issues/63>)
  * increase maximum value of exposure_time/auto_exposure_time_upper_limit (#55 <https://github.com/ros-drivers/flir_camera_driver/issues/55>)
  * add option to set queue_size for ros publisher (#54 <https://github.com/ros-drivers/flir_camera_driver/issues/54>)
  * Added support for Grasshopper3. Identical to Chameleon3, split into separate files for clarity. (#26 <https://github.com/ros-drivers/flir_camera_driver/issues/26>)
  * Feature: horizontal and vertical image reverse (#41 <https://github.com/ros-drivers/flir_camera_driver/issues/41>)
    * Add horizontal/vertical inverse to reconfigure cfg
    * Add ReverseX/ReverseY with setProperty
    Co-authored-by: Fabian Schilling <mailto:fabian.schilling@me.com>
  * Update Spinnaker.cfg (#50 <https://github.com/ros-drivers/flir_camera_driver/issues/50>)
    Fix for correct spelling with capital letter for bool type
  * Add auto exposure ROI parameters (#52 <https://github.com/ros-drivers/flir_camera_driver/issues/52>)
    * spinnaker_camera_driver: setProperty: report available enum values
    Only done on failure. This helps to figure out which enum values are
    available on a particular camera model.
    * spinnaker_camera_driver: expose AE ROI parameters
    This is highly useful when using fisheye lenses, which illuminate only
    a circle in the center of the image. The AE gets confused by the black
    regions around it and overexposes the image.
    This also exposes the "AutoExposureLightingMode" parameter, which allows
    the user to choose a lighting preset (front/back/normal).
  * Fix/frame rate params (#20 <https://github.com/ros-drivers/flir_camera_driver/issues/20>)
    * [spinnaker_camera_driver] Fixed naming of frame rate control params
    * [spinnaker_camera_driver] Format of mono and stereo launchfiles
    * [spinnaker_camera_driver] Updated diagnostics launchfile
  * Removed opencv as depend. (#46 <https://github.com/ros-drivers/flir_camera_driver/issues/46>)
  * Changed the download script to check for destination folder and moved unpack directory. (#44 <https://github.com/ros-drivers/flir_camera_driver/issues/44>)
  * Create the directory if it doesn't exist
  * Remove an unnecessary deb
  * Spinnaker driver now successfully downloads & builds
  * Start overhauling the spinnaker download script so it works with the correct endpoint & matches the general structure of the pointgrey_camera_driver
  * Contributors: Adam Romlein, Chris I-B, Evan Bretl, Fabian Schilling, Ferdinand, Joseph Curtis, Luis Camero, Max Schwarz, Stephan, Tony Baltovski, Yoshua Nava, Yuki Furuta, luis-camero

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Tue, 19 Apr 2022 04:00:00 -0000

ros-noetic-spinnaker-camera-driver (0.2.2-1buster) buster; urgency=high

  * Added new-line at EOF
  * Spinnaker libraries are now all copied to usr/lib
  * Reordered definitions to prevent compiler warnings
  * Contributors: Luis Camero

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Mon, 28 Mar 2022 04:00:00 -0000

ros-noetic-spinnaker-camera-driver (0.2.1-1buster) buster; urgency=high

  * Removed check for build/usr/lib which would cause build to skip Spinnaker SDK install
  * Contributors: Luis Camero

 -- Mike Hosmar <mhosmar@clearpathrobotics.com>  Mon, 21 Mar 2022 04:00:00 -0000

ros-noetic-spinnaker-camera-driver (0.2.0-1buster) buster; urgency=high

  * Changes.
  * Merge pull request #91 <https://github.com/ros-drivers/flir_camera_driver/issues/91> from luis-camero/noetic-devel
    ROS Industrial CI


=== debian/control ===
Source: ros-noetic-spinnaker-camera-driver
Section: misc
Priority: optional
Maintainer: Mike Hosmar <mhosmar@clearpathrobotics.com>
Build-Depends: debhelper (>= 9.0.0), curl, dpkg, libcurl4-openssl-dev, libusb-1.0-0-dev, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-image-exposure-msgs, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-roslint <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-wfov-camera-msgs
Homepage: http://ros.org/wiki/spinnaker_camera_driver
Standards-Version: 3.9.2

Package: ros-noetic-spinnaker-camera-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0-dev, ros-noetic-camera-info-manager, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-image-exposure-msgs, ros-noetic-image-proc, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-wfov-camera-msgs
Description: Spinnaker camera driver based on Spinnaker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-spinnaker-camera-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
